/*######     Copyright (c) 1997-2013 Ufasoft  http://ufasoft.com  mailto:support@ufasoft.com,  Sergey Pavlov  mailto:dev@ufasoft.com #######################################
#                                                                                                                                                                          #
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation;  #
# either version 3, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the      #
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received a copy of the GNU #
# General Public License along with this program; If not, see <http://www.gnu.org/licenses/>                                                                               #
##########################################################################################################################################################################*/

﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;
using System.Windows.Shapes;

namespace Coin {
	public partial class FormPassphrase : Window {
		public FormPassphrase() {
			InitializeComponent();
			labelOldPassword.Visibility = Visibility.Hidden;
			textOldPassword.Visibility = Visibility.Hidden;
		}

		bool CheckFields() {
			if (labelRetype.Visibility == Visibility.Visible) {
				string s = textPassword.Password;
				if (s != textRetype.Password)
					throw new ApplicationException("Retyped string is not the same as Password");
				if (s.Length == 0) {
					if (MessageBox.Show("New password is Empty. Are you sure to make your wallet unecrypted?", "Coin", MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.No)
						return false;
				}
			}
			return true;
		}

		private void OnOk(object sender, RoutedEventArgs e) {
			DialogResult = CheckFields();
		}

	}
}
