/*######     Copyright (c) 1997-2013 Ufasoft  http://ufasoft.com  mailto:support@ufasoft.com,  Sergey Pavlov  mailto:dev@ufasoft.com #######################################
#                                                                                                                                                                          #
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation;  #
# either version 3, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the      #
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received a copy of the GNU #
# General Public License along with this program; If not, see <http://www.gnu.org/licenses/>                                                                               #
##########################################################################################################################################################################*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Globalization;

using Interop.coineng;

namespace Coin {
	public partial class FormSendMoney : Window {
		public FormSendMoney() {
			InitializeComponent();
		}

		public IWallet Wallet;

		private void Window_Closed(object sender, EventArgs e) {
			if (DialogResult == true) {
				if (FormMain.I.EnsurePassphraseUnlock()) {
					var prevCursor = Cursor;
					Cursor = Cursors.Wait;
					string address = textAddress.Text,
						comment = textComment.Text;
					try {
						Wallet.AddRecipient(address, comment);
					} catch (Exception) {
					}
					try {
						var prov = new NumberFormatInfo();
						prov.NumberDecimalSeparator = ".";
						decimal amount = Convert.ToDecimal(textAmount.Text.Replace(',', '.'), prov);
						Wallet.SendTo(amount, address, comment);
					} finally {
						Cursor = prevCursor;
					}
				}
			}

		}

		private void Window_Loaded(object sender, RoutedEventArgs e) {
			labelCurrencySymbol.Content = Wallet.CurrencySymbol;
		}


		private void OnSend(object sender, RoutedEventArgs e) {
			DialogResult = true;
		}

		private void textAmount_TextChanged(object sender, TextChangedEventArgs e) {
			//			return; //!!!D
			decimal amount;
			if (decimal.TryParse(textAmount.Text, out amount)) {
				try {
					labelFee.Content = Wallet.CalcFee(amount).ToString();
				} catch (Exception ex) {
					labelFee.Content = ex.Message;
				}
			}
		}

	}
}
